This service will be undergoing maintenance at 00:00 UTC, 2017-10-23 It is expected to last about 30 minutes
Bug 874689 - Review Request: libuv - Platform layer for node.js
Review Request: libuv - Platform layer for node.js
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Matthias Runge
Fedora Extras Quality Assurance
:
Depends On:
Blocks: 815018
  Show dependency treegraph
 
Reported: 2012-11-08 11:36 EST by Stephen Gallagher
Modified: 2013-04-05 19:01 EDT (History)
7 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2012-11-19 14:00:41 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
mrunge: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Stephen Gallagher 2012-11-08 11:36:29 EST
Spec URL: http://sgallagh.fedorapeople.org/packagereview/libuv/libuv.spec

SRPM URL: http://sgallagh.fedorapeople.org/packagereview/libuv/libuv-0.9.3-0.1.gitd56434a.fc18.src.rpm

Description:
libuv is a new platform layer for Node. Its purpose is to abstract IOCP on
Windows and libev on Unix systems. We intend to eventually contain all platform
differences in this library.

Fedora Account System Username: sgallagh
Comment 1 Matthias Runge 2012-11-09 01:52:19 EST
I can do the review
Comment 2 Matthias Runge 2012-11-09 03:43:48 EST
Package Review
==============

Key:
[x] = Pass
[!] = Fail
[-] = Not applicable
[?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
[!]: Package does not contain duplicates in %files.
     Note: warning: File listed twice: /usr/include/uv-private
See: http://fedoraproject.org/wiki/Packaging/Guidelines#DuplicateFiles


===== MUST items =====

C/C++:
[x]: Header files in -devel subpackage, if present.
[x]: ldconfig called in %post and %postun if required.
[x]: Package does not contain any libtool archives (.la)
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[!]: Package contains no bundled libraries.
Excheption request here:
https://fedorahosted.org/fpc/ticket/231
[x]: Changelog in prescribed format.
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Sources contain only permissible code or content.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[-]: Package requires other packages for directories it uses.
[x]: Package uses nothing in %doc for runtime.
[x]: Package is not known to require ExcludeArch.
[!]: Package does not contain duplicates in %files.
     Note: warning: File listed twice: /usr/include/uv-private
[x]: Permissions on files are set properly.
[x]: Fully versioned dependency in subpackages, if present.
[x]: Package complies to the Packaging Guidelines
[x]: Spec file lacks Packager, Vendor, PreReq tags.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "MIT/X11 (BSD like)", "ISC", "Unknown or generated", "BSD (2 clause)". 4
     files have unknown license. Detailed output of licensecheck in
     /home/mrunge/review/874689-libuv/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: Package consistently uses macro is (instead of hard-coded directory
     names).
[x]: Package is named using only allowed ASCII characters.
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
     Note: Package contains no Conflicts: tag(s)
[x]: Package do not use a name that already exist
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package installs properly.
[x]: Package is not relocatable.
[x]: Requires correct, justified where necessary.
[x]: CheckResultdir
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file is legible and written in American English.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[-]: Package contains systemd file(s) if in need.
[x]: File names are valid UTF-8.
[x]: Useful -debuginfo package or justification otherwise.
[-]: Large documentation must go in a -doc subpackage.
     Note: Documentation size is 40960 bytes in 6 files.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Dist tag is present.
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Final provides and requires are sane (rpm -q --provides and rpm -q
     --requires).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: Scriptlets must be sane, if used.
[!]: SourceX tarball generation or download is documented.
     Note: Package contains tarball without URL, check comments
[x]: SourceX / PatchY prefixed with %{name}.
[x]: SourceX is a working URL.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Spec use %global instead of %define.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.


Rpmlint
-------
Checking: libuv-0.9.3-0.1.gitd56434a.fc19.src.rpm
          libuv-devel-0.9.3-0.1.gitd56434a.fc19.x86_64.rpm
          libuv-0.9.3-0.1.gitd56434a.fc19.x86_64.rpm
          libuv-debuginfo-0.9.3-0.1.gitd56434a.fc19.x86_64.rpm
libuv.src: W: spelling-error Summary(en_US) js -> dis, ks, j
libuv.src: W: spelling-error %description -l en_US libev -> libel, believe
libuv.src: W: strange-permission libuv-snapshot.sh 0775L
libuv.src: W: invalid-url Source0: libuv-0.9.3gitd56434a.tar.gz
libuv.x86_64: W: spelling-error Summary(en_US) js -> dis, ks, j
libuv.x86_64: W: spelling-error %description -l en_US libev -> libel, believe
4 packages and 0 specfiles checked; 0 errors, 6 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint libuv libuv-devel libuv-debuginfo
libuv.x86_64: W: spelling-error Summary(en_US) js -> dis, ks, j
libuv.x86_64: W: spelling-error %description -l en_US libev -> libel, believe
libuv.x86_64: W: undefined-non-weak-symbol /usr/lib64/libuv.so.0.9.3 dlsym
libuv.x86_64: W: undefined-non-weak-symbol /usr/lib64/libuv.so.0.9.3 dlerror
libuv.x86_64: W: undefined-non-weak-symbol /usr/lib64/libuv.so.0.9.3 dlopen
libuv.x86_64: W: undefined-non-weak-symbol /usr/lib64/libuv.so.0.9.3 dlclose
libuv.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libuv.so.0.9.3 /lib64/libstdc++.so.6
libuv.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libuv.so.0.9.3 /lib64/libgcc_s.so.1
3 packages and 0 specfiles checked; 0 errors, 8 warnings.
# echo 'rpmlint-done:'



Requires
--------
libuv-devel-0.9.3-0.1.gitd56434a.fc19.x86_64.rpm (rpmlib, GLIBC filtered):
    
    /sbin/ldconfig  
    /usr/bin/pkg-config  
    libuv = 0.9.3-0.1.gitd56434a.fc19
    libuv.so.0.9.3()(64bit)  
    pkgconfig  

libuv-0.9.3-0.1.gitd56434a.fc19.x86_64.rpm (rpmlib, GLIBC filtered):
    
    /sbin/ldconfig  
    libc.so.6()(64bit)  
    libgcc_s.so.1()(64bit)  
    libm.so.6()(64bit)  
    libpthread.so.0()(64bit)  
    libstdc++.so.6()(64bit)  
    rtld(GNU_HASH)  

libuv-debuginfo-0.9.3-0.1.gitd56434a.fc19.x86_64.rpm (rpmlib, GLIBC filtered):
    



Provides
--------
libuv-devel-0.9.3-0.1.gitd56434a.fc19.x86_64.rpm:
    
    libuv-devel = 0.9.3-0.1.gitd56434a.fc19
    libuv-devel(x86-64) = 0.9.3-0.1.gitd56434a.fc19
    pkgconfig(libuv) = 0.9.3.gitd56434a

libuv-0.9.3-0.1.gitd56434a.fc19.x86_64.rpm:
    
    bundled(libev) = 4.04
    libuv = 0.9.3-0.1.gitd56434a.fc19
    libuv(x86-64) = 0.9.3-0.1.gitd56434a.fc19
    libuv.so.0.9.3()(64bit)  

libuv-debuginfo-0.9.3-0.1.gitd56434a.fc19.x86_64.rpm:
    
    libuv-debuginfo = 0.9.3-0.1.gitd56434a.fc19
    libuv-debuginfo(x86-64) = 0.9.3-0.1.gitd56434a.fc19



MD5-sum check
-------------


Generated by fedora-review 0.3.1 (b71abc1) last change: 2012-10-16
Buildroot used: fedora-rawhide-x86_64
Command line :/usr/bin/fedora-review -b 874689



Issues left:
- bundling excheption currently undecided
- you should change the following from files section: (double included dir)
%{_includedir}/uv-private/
%dir %{_includedir}/uv-private/
just to 
%{_includedir}/uv-private

I'd like to defer the approval until https://fedorahosted.org/fpc/ticket/231 is decided. Apart from that I don't see any issues here.
Comment 3 Stephen Gallagher 2012-11-14 13:59:10 EST
Thanks for the review.

As of today, https://fedorahosted.org/fpc/ticket/231 was approved for a bundling exception.

I've also corrected the doubly-listed directory and uploaded a new version of the package with updated upstream sources:

Spec: http://sgallagh.fedorapeople.org/packagereview/libuv/libuv.spec

SRPM: http://sgallagh.fedorapeople.org/packagereview/libuv/libuv-0.9.3-0.2.git09b0222.fc18.src.rpm


Built in Koji: http://koji.fedoraproject.org/koji/taskinfo?taskID=4688672
Comment 4 Matthias Runge 2012-11-15 02:50:56 EST
Great news, last time I checked for the exception was two days ago.

All issues fixed, this package is approved.
Comment 5 Stephen Gallagher 2012-11-15 07:32:47 EST
New Package SCM Request
=======================
Package Name: libuv
Short Description: Platform layer for node.js
Owners: sgallagh
Branches: f18 f17
InitialCC:
Comment 6 Gwyn Ciesla 2012-11-15 08:19:50 EST
Git done (by process-git-requests).
Comment 7 Orion Poplawski 2012-11-27 18:03:35 EST
Can we get updates for f17 and f18 please?  Thanks!
Comment 8 Orion Poplawski 2012-11-27 18:10:00 EST
Also, this builds on el6 and would be nice to have there.
Comment 9 Stephen Gallagher 2012-11-28 08:34:55 EST
I don't have plans for F17 or EPEL 6 at this time. The reason for this is that libuv is pretty much only usable with Node.js at this time. The Node.js package undergoing review requires OpenSSL 1.0.1 or later, which is presently only available on F18+.

If you have a use for libuv other than with Node.js, let me know. There's nothing preventing me building it on F17 and EPEL 6 technically, but I don't really want to support it there unless it's being used.
Comment 10 Orion Poplawski 2012-11-28 10:41:36 EST
I'm looking at it for julia, but since julia also requires bleeding edge suitesparse which is only in rawhide, I'm fine with libuv not being elsewhere yet.
Comment 11 Fedora Update System 2012-12-18 12:48:45 EST
nodejs-0.9.3-7.fc18,libuv-0.9.3-0.3.git09b0222.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/nodejs-0.9.3-7.fc18,libuv-0.9.3-0.3.git09b0222.fc18
Comment 12 Stephen Gallagher 2012-12-20 09:27:12 EST
Package Change Request
======================
Package Name: libuv
New Branches: el6
Owners: sgallagh
InitialCC: 

I'm working with Node.JS upstream to enable its use on systems with a slightly older openssl version to support EPEL 6. With that in mind, we're going to need to build libuv on EPEL 6 as well.
Comment 13 Stephen Gallagher 2012-12-20 09:28:32 EST
Package Change Request
======================
Package Name: libuv
New Branches: el6
Owners: sgallagh patches
InitialCC: 

Correcting the request
Comment 14 Gwyn Ciesla 2012-12-20 09:36:07 EST
Git done (by process-git-requests).
Comment 15 Fedora Update System 2013-04-05 19:01:21 EDT
v8-3.14.5.8-1.fc18, nodejs-0.10.2-1.fc18, libuv-0.10.3-1.fc18 has been pushed to the Fedora 18 stable repository.  If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.